ResidentSeg segment para public 'resident'
ResidentSeg ends

EndResident segment para public 'EndRes'
EndResident ends

	.xlist
	.286
	include stdlib.a
	includelib C:\daten\prog\aoa\stdlib\lib\stdlib.lib
	.list

ResidentSeg segment para public 'resident'
	assume cs:ResidentSeg, ds:ResidentSeg

; resident code and data follows
OldInt1c dword   ? ; Original Int1c Vector
PSP word    ? ; must be here
OldJoy1	db 0
NewJoy1 db 0
OldJoy2 db 0
NewJoy2	db 0
CodeLt1 db 4bh ; 4 
CodeRt1 db 4dh ; 6
CodeDn1 db 50h ; 2
CodeUp1 db 48h ; 8
CodeF11 db 52h ; 0
CodeF21 db 53  ; .
CodeLt2 db 20h ; a
CodeRt2 db 1eh ; d
CodeDn2 db 1fh ; s
CodeUp2 db 11h ; w
CodeF12 db 2eh ; c
CodeF22 db 2fh ; v
MyInt1c proc far
	assume ds:ResidentSeg
	;assume ss:ResidentSeg
	push ds
	push es
	;push ss
  	pusha ; save all registers
	mov ax,ResidentSeg
	mov ds,ax
	;mov ss,ax
	;mov sp,EndStack

	pushf
	call OldInt1c

	;jmp EndInt1c
	;dec byte ptr cs:Counter
	cld
	;mov ax, 0b800h
	;mov es,ax
	;mov di, 000h

	;mov ah,cs:Counter
	;mov al,cs:Counter

	;mov cx,40
	;rep stosw

; Check joysticks
	mov ah,0h
	mov bh,0h ; Clear both target ports
	mov bl,001h ; Load Bit 1
readloop:
	mov al,bl ; Load Bit into target register
	xor al,0ffh ; Invert it
	mov dx,378h ; Data Port &378
	out dx,al
	mov dx,379h
	in al,dx ; read Status port
	rcl al,1
	rcr ah,1 ; Rotate !Busy Flag through Carry
	rcl al,1
	rcr bh,1 ; Rotate ACK Flag through Carry 
	sal bl,1 ; Prepare next bit...
	jnz readloop
	xor bh,0ffh

	mov NewJoy1, ah
	mov NewJoy2, bh
	xor ah, OldJoy1 ; check for changes

	; test first joystick
	test ah,01h
	jz NoRight
	;check right direction
	mov al,CodeRt1
	mov ah,01h
	call ChkPress
NoRight:
	test ah,02h
	jz NoLeft
	;check left direction
	mov al,CodeLt1
	mov ah,02h
	call ChkPress
NoLeft:
	test ah,004h
	jz NoDown
	;check down direction
	mov al,CodeDn1
	mov ah,04h
	call ChkPress
NoDown:
	test ah,008h ; up
	jz NoUp
	;check up direction
	mov al,CodeUp1
	mov ah,08h
	call ChkPress
NoUp: 
	test ah,010h
	jz NoFire1
	; check fire button 1
	mov al,CodeF11
	mov ah,10h
	call ChkPress
NoFire1:
	test ah,020h
	jz NoFire2
	; Check fire button 2
	mov al,CodeF21
	mov ah,20h
	call ChkPress
NoFire2:
	; check joystick 2
	mov ah,NewJoy2
	xor ah,OldJoy2 ; check for changes 
	test ah,01h
	jz NoRight2
	;check right direction
	mov al,CodeRt2
	mov ah,01h
	call ChkPress2
NoRight2:
	test ah,02h
	jz NoLeft2
	;check left direction
	mov al,CodeLt2
	mov ah,02h
	call ChkPress2
NoLeft2:
	test ah,004h
	jz NoDown2
	;check down direction
	mov al,CodeDn2
	mov ah,04h
	call ChkPress2
NoDown2:
	test ah,008h ; up
	jz NoUp2
	;check up direction
	mov al,CodeUp2
	mov ah,08h
	call ChkPress2
NoUp2: 
	test ah,010h
	jz NoFire12
	; check fire button 1
	mov al,CodeF12
	mov ah,10h
	call ChkPress2
NoFire12:
	test ah,020h
	jz NoFire22
	; Check fire button 2
	mov al,CodeF22
	mov ah,20h
	call ChkPress2
NoFire22:
	; save joystick values for later use
	mov ah,NewJoy1
	mov OldJoy1,ah
	mov ah,NewJoy2
	mov OldJoy2,ah
	;jmp EndInt1c
EndInt1c:                
	;sti
	;jmp ResidentSeg:OldInt1c
	popa
	;pop ss
	pop es
	pop ds
	iret
MyInt1c endp
include fakekbd.inc
ChkPress proc near
; Check if Stick is pressed or released, send corresponsding keycode
; Input: al:Keycode, ah: bitfield to test
; Destroys: bx
; untested
 	mov bl, NewJoy1
	test bl,ah
	jz ChkPressKeyup
	call PutInAtBuffer
	ret
ChkPressKeyup:
	add al,80h ; release key code
	call PutInAtBuffer
	ret
ChkPress endp
ChkPress2 proc near
; Check if Stick 2 is pressed or released, send corresponsding keycode
; Input: al:Keycode, ah: bitfield to test
; Destroys: bx
; untested
 	mov bl, NewJoy2
	test bl,ah
	jz ChkPress2Keyup
	call PutInAtBuffer
	ret
ChkPress2Keyup:
	add al,80h ; release key code
	call PutInAtBuffer
	ret
ChkPress2 endp

ResidentSeg     ends

dseg            segment para public 'data'
; transient data follows
dseg            ends

cseg            segment para public 'code'
		assume cs:cseg, ds:ResidentSeg
; transient code follows
Main proc
	meminit
	mov ax, ResidentSeg
	mov ds,ax
	mov ax,0
	mov es,ax

	;jmp noInstall
	; Install new int handler
	cli
	mov ax, es:[1ch*4]
	mov word ptr OldInt1c, ax
	mov ax,es:[1ch*4+2]
	mov word ptr OldInt1c+2, ax 
	mov es:[1ch*4], offset MyInt1c
	mov es:[1ch*4+2], seg ResidentSeg
	sti
noInstall:
	;get PSP
	mov ah, 62h
	int 21h

	; compute size of TSR and go resident
	mov dx, EndResident
	sub dx,bx
	mov ax,3100h
	int 21h
Main endp
cseg ends
		
sseg	segment para stack 'stack'
stk	db 1024  dup ("stack")
sseg	ends

zzzzzzseg segment para public 'zzzzzz'
lastbytes db 16 dup (?)
zzzzzzseg ends

end Main

